=== examples/cpuid/CMakeLists.txt ===
add_executable(cpuid main.cpp)
target_link_libraries(cpuid Vc)
