=== debian/changelog ===
vc (1.3.2-1mx17+1) mx; urgency=medium

  * Rebuild for MX-17.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 31 Oct 2017 17:34:35 -0700

vc (1.3.2-1) unstable; urgency=medium

  [ Simon Quigley ]
  * New upstream release.
  * Change Vcs-Git and Vcs-Browser fields to reflect a move to collab-maint.
  * Fix build on kFreeBSD by backporting upstream patch in fix-ftbfs-on-
    kfreebsd-amd64.patch (Closes: #861096).
  * Bump Standards-version to 4.0.0, no changes needed.

  [ Mattia Rizzolo ]
  * Fix debian/watch to properly match the upstream releases.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Mon, 19 Jun 2017 13:56:15 -0500

vc (1.3.1-1) unstable; urgency=medium

  * Initial upload to the Debian archive (Closes: #846491).
  * New upstream release.
  * Add Vcs-Git and Vcs-Browser fields.
  * Update the maintainer field.
  * Update the package description.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Fri, 21 Apr 2017 20:11:05 -0500
