=== debian/control ===
Source: vc
Priority: extra
Maintainer: Simon Quigley <tsimonq2@ubuntu.com>
Build-Depends: cmake, debhelper (>= 10)
Standards-Version: 4.0.0
Section: libs
Homepage: https://github.com/VcDevel/Vc
Vcs-Git: https://anonscm.debian.org/git/collab-maint/vc.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/vc.git

Package: vc-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library to ease explicit vectorization of C++ code
 Vc is a free software library to ease explicit vectorization of C++
 code. It has an intuitive API and provides portability between
 different compilers and compiler versions as well as portability
 between different vector instruction sets. Thus an application
 written with Vc can be compiled for:
  - AVX and AVX2
  - SSE2 up to SSE4.2 or SSE4a
  - Scalar
  - MIC
  - AVX-512 (in development)
  - NEON (in development)
  - NVIDIA GPUs / CUDA (in development)
