## vc 1.3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,16 @@
 include (OptimizeForArchitecture)
 
 vc_determine_compiler()
-find_package(MIC)
+
+if("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "(x86|AMD64|amd64)")
+   set(Vc_X86 TRUE)
+   find_package(MIC)
+elseif("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "(arm|aarch32|aarch64)")
+   message(WARNING "No optimized implementation of the Vc types available for ${CMAKE_SYSTEM_PROCESSOR}")
+   set(Vc_ARM TRUE)
+else()
+   message(WARNING "No optimized implementation of the Vc types available for ${CMAKE_SYSTEM_PROCESSOR}")
+endif()
 
 option(USE_CCACHE "If enabled, ccache will be used (if it exists on the system) to speed up recompiles." OFF)
 if(USE_CCACHE)
@@ -132,12 +141,13 @@
 endif()
 
 set(_srcs src/const.cpp)
-if("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "([x3-7]86|AMD64)")
-
+if(Vc_X86)
    list(APPEND _srcs src/cpuid.cpp src/support_x86.cpp)
    vc_compile_for_all_implementations(_srcs src/trigonometric.cpp ONLY SSE2 SSE3 SSSE3 SSE4_1 AVX SSE+XOP+FMA4 AVX+XOP+FMA4 AVX+XOP+FMA AVX+FMA AVX2+FMA+BMI2)
    vc_compile_for_all_implementations(_srcs src/sse_sorthelper.cpp ONLY SSE2 SSE4_1 AVX AVX2+FMA+BMI2)
    vc_compile_for_all_implementations(_srcs src/avx_sorthelper.cpp ONLY AVX AVX2+FMA+BMI2)
+elseif(Vc_ARM)
+   list(APPEND _srcs src/support_dummy.cpp)
 else()
    message(FATAL_ERROR "Unsupported target architecture '${CMAKE_SYSTEM_PROCESSOR}'. No support_???.cpp file exists for this architecture.")
 endif()
