=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -110,7 +110,11 @@
    set(_extra_flags)
    set(name ${_name})
    set(_state 0)
-   set(_targets "Scalar;SSE;AVX1;AVX2;MIC")
+   if(Vc_X86)
+      set(_targets "Scalar;SSE;AVX1;AVX2;MIC")
+   else()
+      set(_targets "Scalar")
+   endif()
    foreach(_arg ${ARGN})
       if("${_arg}" STREQUAL "FLAGS")
          set(_state 0)
@@ -270,16 +274,9 @@
 vc_add_test(load)
 vc_add_test(store)
 vc_add_test(gather)
-vc_add_test(gather Vc_USE_BSF_GATHERS TARGETS SSE AVX AVX2)
-vc_add_test(gather Vc_USE_POPCNT_BSF_GATHERS TARGETS SSE AVX AVX2)
-vc_add_test(gather Vc_USE_SET_GATHERS TARGETS SSE AVX AVX2)
 vc_add_test(scatter)
-vc_add_test(scatter Vc_USE_BSF_SCATTERS TARGETS SSE AVX AVX2)
-vc_add_test(scatter Vc_USE_POPCNT_BSF_SCATTERS TARGETS SSE AVX AVX2)
 vc_add_test(ulp)
 vc_add_test(logarithm)
-vc_add_test(logarithm Vc_LOG_ILP TARGETS SSE AVX AVX2)
-vc_add_test(logarithm Vc_LOG_ILP2 TARGETS SSE AVX AVX2)
 vc_add_test(trigonometric)
 vc_add_test(math)
 vc_add_test(reductions)
@@ -290,8 +287,17 @@
 vc_add_test(deinterleave)
 vc_add_test(gatherinterleavedmemory)
 vc_add_test(scatterinterleavedmemory)
-vc_add_test(scatterinterleavedmemory Vc_USE_MASKMOV_SCATTER TARGETS SSE AVX AVX2)
 vc_add_test(casts Vc_DEFAULT_TYPES)
+if(Vc_X86)
+   vc_add_test(gather Vc_USE_BSF_GATHERS TARGETS SSE AVX AVX2)
+   vc_add_test(gather Vc_USE_POPCNT_BSF_GATHERS TARGETS SSE AVX AVX2)
+   vc_add_test(gather Vc_USE_SET_GATHERS TARGETS SSE AVX AVX2)
+   vc_add_test(scatter Vc_USE_BSF_SCATTERS TARGETS SSE AVX AVX2)
+   vc_add_test(scatter Vc_USE_POPCNT_BSF_SCATTERS TARGETS SSE AVX AVX2)
+   vc_add_test(logarithm Vc_LOG_ILP TARGETS SSE AVX AVX2)
+   vc_add_test(logarithm Vc_LOG_ILP2 TARGETS SSE AVX AVX2)
+   vc_add_test(scatterinterleavedmemory Vc_USE_MASKMOV_SCATTER TARGETS SSE AVX AVX2)
+endif()
 option(BUILD_EXTRA_CAST_TESTS "build all possible combinations of simd_cast tests (compiles for a very long time)" FALSE)
 if(BUILD_EXTRA_CAST_TESTS)
    vc_add_test(casts Vc_EXTRA_TYPES)
@@ -309,6 +315,3 @@
 mark_as_advanced(OBJDUMP)
 
 if(OBJDUMP)
-   macro(test_abi _target _impl)
-      set(_test test_${_target})
-      if("${_impl}" STREQUAL "MIC")
