=== examples/matrix/CMakeLists.txt ===
build_example(matrix main.cpp)
