=== examples/test_inside/CMakeLists.txt ===
build_example(test_inside main.cpp)
