=== debian/changelog ===
vc (1.3.3-4) unstable; urgency=medium

  * Bump Standards-version to 4.1.4, no changes needed.
  * Update Vcs-* for the qt-extras -> extras rename.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sun, 03 Jun 2018 00:01:24 -0500

vc (1.3.3-3) unstable; urgency=medium

  * Use wildcard architectures instead of explicitly defining each
    architecture, thanks to Pino Toscano for the patch (Closes: #892600).
  * Move to the Qt Extras umbrella (under the Qt/KDE Team). As such:
    - Rename Vcs-* to reflect the repository relocation.
    - Set the Qt/KDE Team as the maintainer with myself as the only
      comaintainer (other comaintainers are absolutely welcome!).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Thu, 15 Mar 2018 20:31:52 -0500

vc (1.3.3-2) unstable; urgency=medium

  * Add back support for i386 in CMakeLists.txt.
  * Only build on the architectures that upstream supports, which is: amd64
    arm* i386 x32 (Closes: #860987, LP: #1298996).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 10 Mar 2018 21:16:11 -0600

vc (1.3.3-1) unstable; urgency=medium

  * New upstream release.
    - Remove fix-ftbfs-on-kfreebsd-amd64.patch because it has been applied
      upstream.
  * Update Standards-version to 4.1.3:
    - Change Priority: extra to Priority: optional.
  * Update the debhelper compat to 11, no changes needed.
  * Make the copyright format URI HTTPS.
  * Update Vcs-* to reflect the move to Salsa.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 27 Feb 2018 23:41:01 -0600
