=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: vc
-Priority: extra
-Maintainer: Simon Quigley <tsimonq2@ubuntu.com>
-Build-Depends: cmake, debhelper (>= 10)
-Standards-Version: 4.0.0
+Priority: optional
+Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Uploaders: Simon Quigley <tsimonq2@ubuntu.com>
+Build-Depends: cmake, debhelper (>= 11)
+Standards-Version: 4.1.4
 Section: libs
 Homepage: https://github.com/VcDevel/Vc
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/vc.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/vc.git
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/vc
+Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/vc.git
 
 Package: vc-dev
 Section: libdevel
-Architecture: any
+Architecture: any-amd64 any-arm any-arm64 any-i386
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Library to ease explicit vectorization of C++ code
  Vc is a free software library to ease explicit vectorization of C++
